#! /usr/bin/env python2

# This is free and unencumbered software released into the public domain.

# Anyone is free to copy, modify, publish, use, compile, sell, or
# distribute this software, either in source code form or as a compiled
# binary, for any purpose, commercial or non-commercial, and by any
# means.

# In jurisdictions that recognize copyright laws, the author or authors
# of this software dedicate any and all copyright interest in the
# software to the public domain. We make this dedication for the benefit
# of the public at large and to the detriment of our heirs and
# successors. We intend this dedication to be an overt act of
# relinquishment in perpetuity of all present and future rights to this
# software under copyright law.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
# OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
# ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

# For more information, please refer to <http://unlicense.org/>

from gimpfu import *
import math

def python_spindup(img, layer, angle, steps, xCenter, yCenter):
	pdb.gimp_image_undo_group_start(img)
	for x in range(0, steps):
		newLayer = pdb.gimp_layer_copy(layer, pdb.gimp_drawable_has_alpha(layer))
		pdb.gimp_image_insert_layer(img, newLayer, None, -1)
		newLayer = pdb.gimp_item_transform_rotate(newLayer, angle * math.pi / 180 / steps * (x + 1), False, xCenter, yCenter)
	pdb.gimp_image_undo_group_end(img)
	
register(
		"python_fu_spindup",
		"Spin Duplicates",
		"Duplicates and rotates layer",
		"Kota Weaver",
		"Kota Weaver",
		"2012",
		"<Image>/Filters/Distorts/Spin Duplicates...",
		"*",
		[
			(PF_FLOAT, "angle", "Angle of Rotation", 90),
			(PF_INT, "steps", "Number of Steps", 10),
			(PF_FLOAT, "xCenter", "Horizontal Center of Rotation", 0),
			(PF_FLOAT, "yCenter", "Vertical Center of Rotation", 0)
		],
		[],
		python_spindup)
		
main()
